import customtkinter



app = customtkinter.CTk()
app.title("Welcome to Hand Tracking")

def startBtn_callback():
    print("starting")
    app.destroy()

welcome = customtkinter.CTkLabel(app, text="Welcome to Hand Tracking, Let's Get You Started!")
welcome.grid(row=0,column=0,padx=10)

confQuest = customtkinter.CTkLabel(app, text="  Video Conference Software  ")
confQuest.grid(row=1,column=0,padx=10)

confSoft = customtkinter.StringVar(value="Zoom")
confSoftBtn = customtkinter.CTkSegmentedButton(app, values=["Zoom", "Meet", "Teams"], variable=confSoft)
confSoftBtn.grid(row=2, column=0,padx=10)

startBtn = customtkinter.CTkButton(app, text="Get Started!", command=startBtn_callback)
startBtn.grid(row=3, column=0,padx=10,pady=10)

app.mainloop()





import tkinter as tk
import mouse
import keyboard
import math
import time
import concurrent.futures

#Earlier GUI stuff
chart = tk.Tk()
chart.attributes('-topmost',True)
status = tk.Text(chart,height=1,width=32)
status.insert(tk.INSERT,"Loading Please Wait...")
status.pack()
chart.update()
#for gestures
gN = 0
gestMode = 1
prevGestMode = 0
pointSelect = -1
oldCords = [[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5]]

handAvg = [[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5],[0.5,0.5]]

def calcDist(p1,p2):
    return math.sqrt((p1[0]-p2[0])**2+(p1[1]-p2[1])**2)

import cv2
import mediapipe as mp
mp_drawing = mp.solutions.drawing_utils
mp_hands = mp.solutions.hands
pointRM = None

#GUI STUFF
handMap = tk.Canvas(chart,width=256,height=256)
handMap.pack()
pointCanv = None
def drawPoint(x,y):
    global handMap
    r = 2
    handMap.create_oval(x-r,y-r,x+r,y+r,fill='#000')
def drawPoints(hand):
    if hand is not None:
        global handMap
        handMap.delete("all")

        for point in hand:
            drawPoint(point[0] * 256,point[1] * 256)
        handMap.pack()
cap = cv2.VideoCapture(0)
#Function to change status text
def setStatus(text):
    global status
    status.delete("1.0","end")
    status.insert(tk.INSERT,text)
    status.pack()
    chart.update()
    
#Remove Loading Screen
setStatus("No Gesture Detected")
prevVolUp = False
def fixVol(prev):
    if prev:
        keyboard.press_and_release("volume up")
    else:
        keyboard.press_and_release("volume down")

def gestures(hand):
    scale = calcDist(hand[0],hand[1]) * 20
    global gN, oldCords, pointRM, pointCanv, gestMode, prevGestMode, pointSelect
    if gestMode == 0: # Confirmation Window
        try:
            pointRM.update()
        except:
            t=0
        if calcDist(hand[8],hand[5]) < scale * 0.1 and calcDist(hand[12],hand[9]) < scale * 0.1 and calcDist(hand[16],hand[13]) < scale * 0.1 and calcDist(hand[20],hand[17]) < scale * 0.1 and hand[0][0] - hand[1][0] < scale * 0.025:
            if hand[4][1] + scale * 0.1 < hand[1][1]:
                #Thumbs Up Start
                setStatus("Confirmed")
                pointRM.destroy()
                gestMode = pointSelect + 1
            elif hand[4][1] - scale * 0.1 > hand[1][1]:
                #Thumbs Down Start
                setStatus("Returning to Previous Mode")
                pointRM.destroy()
                gestMode = prevGestMode
    elif gestMode == 1: # Workflow
        if gN==0:
            #Gesture Detection goes here
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Start
                print("started pinch")
                setStatus("Pinching")
                keyboard.press("windows")
                oldCords[8][0] = handAvg[8][0]
                oldCords[8][1] = handAvg[8][1]
                gN = 1
            else:
                keyboard.release("windows")
            temp = calcDist(hand[8],hand[5]) - scale * 0.025
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Start
                pointRM = tk.Tk()
                pointRM.attributes('-topmost',True)
                pointRM.overrideredirect(1)
                pointRM.eval('tk::PlaceWindow . center')
                pointCanv = tk.Canvas(pointRM,width=256,height=256)
                pointCanv.pack()
                setStatus("Pointing")
                gN = 2
            if calcDist(hand[4],hand[5]) < scale * 0.1 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Start
                oldCords[0][0] = handAvg[0][0]
                oldCords[0][1] = handAvg[0][1]
                setStatus("Grabbing")
                gN = 3  
        if gN==1:
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Loop
                if handAvg[8][0] - oldCords[8][0] > scale * 0.1:
                    keyboard.press_and_release("right")
                    gN = 0
                if handAvg[8][0] - oldCords[8][0] < scale * -0.1:
                    keyboard.press_and_release("left")
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] > scale * 0.1:
                    keyboard.press_and_release("down")
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] < scale * -0.1:
                    keyboard.press_and_release("up")
                    gN = 0

            else:
                setStatus("No Gesture Detected - Workflow")
                #Pinch Release
                gN = 0
        if gN==2:
            temp = calcDist(hand[8],hand[5])
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Loop
                pointCanv.delete('all')
                if hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='yellow')
                else:
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='white')
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='yellow')
                else:
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='white')
                if hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='yellow')
                else:
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='white')
                if hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='yellow')
                else:
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='white')
                pointCanv.create_text(128, 32, text="Media",font=('Helvetica','15','bold'))
                pointCanv.create_text(208, 128, text="Mouse",font=('Helvetica','15','bold'))
                pointCanv.create_text(128, 208, text=confSoft.get(),font=('Helvetica','15','bold'))
                pointCanv.create_text(44, 128, text="Browser",font=('Helvetica','15','bold'))
                pointCanv.pack()
            else:
                #Point Release
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Up Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 1
                    setStatus("Confirmation - media")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to media",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                elif hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Right Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 2
                    setStatus("Confirmation - mouse")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to mouse",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                elif hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Bottom Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 3
                    setStatus("Confirmation - " + confSoft.get())
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to "+confSoft.get(),font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                elif hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Left Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 4
                    setStatus("Confirmation - Browser")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Browser",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                else:
                    setStatus("No Gesture Detected - Workflow")
                gN = 0
        if gN==3:
            gn = 0
            if calcDist(hand[4],hand[6]) < scale * 0.2 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Loop
                if handAvg[0][0] - oldCords[0][0] > scale * 0.1:
                    keyboard.press_and_release("ctrl+windows+left")
                    gN = 0
                if handAvg[0][0] - oldCords[0][0] < scale * -0.1:
                    keyboard.press_and_release("ctrl+windows+right")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] > scale * 0.1:
                    keyboard.press_and_release("ctrl+windows+down")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] < scale * -0.1:
                    keyboard.press_and_release("ctrl+windows+up")
                    gN = 0
                t = 0
            else:
                gN = 0
                setStatus("No Gesture Detected - Workflow")
    elif gestMode == 2: # Media
        if gN==0:
            #Gesture Detection goes here
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Start
                setStatus("Pinching")
                oldCords[8][0] = handAvg[8][0]
                oldCords[8][1] = handAvg[8][1]
                gN = 1
            temp = calcDist(hand[8],hand[5]) - scale * 0.025
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Start
                pointRM = tk.Tk()
                pointRM.attributes('-topmost',True)
                pointRM.overrideredirect(1)
                pointRM.eval('tk::PlaceWindow . center')
                pointCanv = tk.Canvas(pointRM,width=256,height=256)
                pointCanv.pack()
                setStatus("Pointing")
                gN = 2
            if calcDist(hand[4],hand[5]) < scale * 0.1 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Start
                oldCords[0][0] = handAvg[0][0]
                oldCords[0][1] = handAvg[0][1]
                setStatus("Grabbing")
                gN = 3  
        if gN==1:
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Loop
                if handAvg[8][0] - oldCords[8][0] > scale * 0.1:
                    keyboard.press_and_release("previous track")
                    gN = 0
                if handAvg[8][0] - oldCords[8][0] < scale * -0.1:
                    keyboard.press_and_release("next track")
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] > scale * 0.01:
                    keyboard.press_and_release("volume down")
                    prevVolUp = False
                    for x in range(int(handAvg[8][1] - oldCords[8][1] * -5)):
                        keyboard.press_and_release("volume down")
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] < scale * -0.01:
                    keyboard.press_and_release("volume up")
                    prevVolUp = False
                    for x in range(int(handAvg[8][1] - oldCords[8][1] * -5)):
                        keyboard.press_and_release("volume up")
                        
                    gN = 0
                
            else:
                #Pinch Release
                setStatus("No Gesture Detected - Media")
                gN = 0
        if gN==2:
            temp = calcDist(hand[8],hand[5])
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Loop
                pointCanv.delete('all')
                if hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='yellow')
                else:
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='white')
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='yellow')
                else:
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='white')
                if hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='yellow')
                else:
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='white')
                if hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='yellow')
                else:
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='white')
                pointCanv.create_text(128, 32, text="Workflow",font=('Helvetica','15','bold'))
                pointCanv.create_text(208, 128, text="Mouse",font=('Helvetica','15','bold'))
                pointCanv.create_text(128, 208, text=confSoft.get(),font=('Helvetica','15','bold'))
                pointCanv.create_text(44, 128, text="Browser",font=('Helvetica','15','bold'))
                pointCanv.pack()
            else:
                #Point Release
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Up Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 0
                    setStatus("Confirmation - workflow")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Workflow",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 2
                elif hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Right Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 2
                    setStatus("Confirmation - mouse")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Mouse",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 2
                elif hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Bottom Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 3
                    setStatus("Confirmation - " + confSoft.get())
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to " + confSoft.get(),font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 2
                elif hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Left Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 4
                    setStatus("Confirmation - window")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Browser",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 2
                else:
                    setStatus("No Gesture Detected - Workflow")
                gN = 0
        if gN==3:
        
            if calcDist(hand[4],hand[6]) < scale * 0.2 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Loop
                if handAvg[0][0] - oldCords[0][0] > scale * 0.1:
                    keyboard.press_and_release("windows+a")
                    gN = 0
                if handAvg[0][0] - oldCords[0][0] < scale * -0.1:
                    keyboard.press_and_release("windows+n")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] > scale * 0.1:
                    keyboard.press_and_release("play/pause")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] < scale * -0.1:
                    keyboard.press_and_release("select media")
                    gN = 0
                t = 0
            else:
                print("released grab")
                gN = 0
                setStatus("No Gesture Detected - Media")
    elif gestMode == 3: # Mouse
        if gN==0:
            #Gesture Detection goes here
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Start
                setStatus("Pinching")
                oldCords[8][0] = handAvg[8][0]
                oldCords[8][1] = handAvg[8][1]
                gN = 1
            temp = calcDist(hand[8],hand[5]) - scale * 0.025
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Start
                pointRM = tk.Tk()
                pointRM.attributes('-topmost',True)
                pointRM.overrideredirect(1)
                pointRM.eval('tk::PlaceWindow . center')
                pointCanv = tk.Canvas(pointRM,width=256,height=256)
                pointCanv.pack()
                setStatus("Pointing")
                gN = 2
            if calcDist(hand[4],hand[5]) < scale * 0.1 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Start
                oldCords[0][0] = handAvg[0][0]
                oldCords[0][1] = handAvg[0][1]
                setStatus("Grabbing")
                gN = 3  
        if gN==1:
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                mouse.move((hand[8][0] - oldCords[8][0]) ** 3 * 400, (handAvg[8][1] - oldCords[8][1]) ** 3 * 400,absolute=False)
            else:
                #Pinch Release
                if(calcDist(oldCords[8],handAvg[8]) < 0.05):
                    mouse.click()
                setStatus("No Gesture Detected - Mouse")
                gN = 0
        if gN==2:
            temp = calcDist(hand[8],hand[5])
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Loop
                pointCanv.delete('all')
                if hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='yellow')
                else:
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='white')
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='yellow')
                else:
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='white')
                if hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='yellow')
                else:
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='white')
                if hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='yellow')
                else:
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='white')
                pointCanv.create_text(128, 32, text="Workflow",font=('Helvetica','15','bold'))
                pointCanv.create_text(208, 128, text="Media",font=('Helvetica','15','bold'))
                pointCanv.create_text(128, 208, text=confSoft.get(),font=('Helvetica','15','bold'))
                pointCanv.create_text(44, 128, text="Browser",font=('Helvetica','15','bold'))
                pointCanv.pack()
            else:
                #Point Release
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Up Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 0
                    setStatus("Confirmation - workflow")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Workflow",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 3
                elif hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Right Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 1
                    setStatus("Confirmation - media")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Media",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 3
                elif hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Bottom Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 3
                    setStatus("Confirmation - window")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to "+confSoft.get(),font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 3
                elif hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Left Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 4
                    setStatus("Confirmation - window")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Browser",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 3
                else:
                    setStatus("No Gesture Detected - Mouse")
                gN = 0
        if gN==3:
            if calcDist(hand[4],hand[6]) < scale * 0.2 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Loop
                if handAvg[0][0] - oldCords[0][0] > scale * 0.1:
                    mouse.double_click()
                    gN = 0
                if handAvg[0][0] - oldCords[0][0] < scale * -0.1:
                    mouse.right_click()
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] > scale * 0.1:
                    keyboard.press("ctrl")
                    mouse.click()
                    keyboard.release("ctrl")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] < scale * -0.1:
                    keyboard.press_and_release("select media")
                    gN = 0
                t = 0
            else:
                print("released grab")
                gN = 0
                setStatus("No Gesture Detected - Mouse")
    elif gestMode == 4: # VideoConferencing
        if gN==0:
            #Gesture Detection goes here
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Start
                print("started pinch")
                setStatus("Pinching")
                oldCords[8][0] = handAvg[8][0]
                oldCords[8][1] = handAvg[8][1]
                gN = 1
            temp = calcDist(hand[8],hand[5]) - scale * 0.025
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Start
                pointRM = tk.Tk()
                pointRM.attributes('-topmost',True)
                pointRM.overrideredirect(1)
                pointRM.eval('tk::PlaceWindow . center')
                pointCanv = tk.Canvas(pointRM,width=256,height=256)
                pointCanv.pack()
                setStatus("Pointing")
                gN = 2
            if calcDist(hand[4],hand[5]) < scale * 0.1 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Start
                oldCords[0][0] = handAvg[0][0]
                oldCords[0][1] = handAvg[0][1]
                setStatus("Grabbing")
                gN = 3  
        if gN==1:
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Loop
                cf = confSoft.get()
                if handAvg[8][0] - oldCords[8][0] > scale * 0.1: # Mute/Unmute
                    if cf == "Zoom":
                        keyboard.press_and_release("alt+a")
                    elif cf == "Teams":
                        keyboard.press_and_release("ctrl+shift+m")

                    gN = 0
                if handAvg[8][0] - oldCords[8][0] < scale * -0.1: # Video
                    if cf == "Zoom":
                        keyboard.press_and_release("alt+v")
                    elif cf == "Teams":
                        keyboard.press_and_release("ctrl+shift+o")
                        
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] > scale * 0.1: 
                    if cf == "Zoom":
                        keyboard.press_and_release("alt+y")
                    elif cf == "Teams":
                        keyboard.press_and_release("ctrl+shift+k")
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] < scale * -0.1: # Raise Hand
                    if cf == "Zoom":
                        keyboard.press_and_release("alt+y")
                    elif cf == "Teams":
                        keyboard.press_and_release("ctrl+shift+k")
                    gN = 0
            else:
                setStatus("No Gesture Detected - " + confSoft.get())
                #Pinch Release
                gN = 0
        if gN==2:
            temp = calcDist(hand[8],hand[5])
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Loop
                pointCanv.delete('all')
                if hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='yellow')
                else:
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='white')
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='yellow')
                else:
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='white')
                if hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='yellow')
                else:
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='white')
                if hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='yellow')
                else:
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='white')
                pointCanv.create_text(128, 32, text="Workflow",font=('Helvetica','15','bold'))
                pointCanv.create_text(208, 128, text="Media",font=('Helvetica','15','bold'))
                pointCanv.create_text(128, 208, text="Mouse",font=('Helvetica','15','bold'))
                pointCanv.pack()
            else:
                #Point Release
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Up Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 0
                    setStatus("Confirmation - workflow")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to workflow",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 4
                elif hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Right Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 1
                    setStatus("Confirmation - media")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to media",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 4
                elif hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Bottom Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 2
                    setStatus("Confirmation - mouse")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to mouse",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 4
                elif hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Left Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 3
                    setStatus("Confirmation - browser")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    textStr = "Are you sure you want to switch modes to browser?"
                    confirmation = tk.Text(pointRM,width=len(textStr),height=1)
                    confirmation.insert(tk.INSERT,textStr)
                    confirmation.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 4
                else:
                    setStatus("No Gesture Detected - " + confSoft.get())
                gN = 0
        if gN==3:
            gn = 0
            if calcDist(hand[4],hand[6]) < scale * 0.2 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Loop
                if handAvg[0][0] - oldCords[0][0] > scale * 0.1:
                    keyboard.press_and_release("ctrl+windows+left")
                    gN = 0
                if handAvg[0][0] - oldCords[0][0] < scale * -0.1:
                    keyboard.press_and_release("ctrl+windows+right")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] > scale * 0.1:
                    keyboard.press_and_release("ctrl+windows+down")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] < scale * -0.1:
                    keyboard.press_and_release("ctrl+windows+up")
                    gN = 0
                t = 0
            else:
                gN = 0
                setStatus("No Gesture Detected - " + confSoft.get())
    elif gestMode == 5: # Browser
        if gN==0:
            #Gesture Detection goes here
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Start
                print("started pinch")
                setStatus("Pinching")
                oldCords[8][0] = handAvg[8][0]
                oldCords[8][1] = handAvg[8][1]
                gN = 1
            temp = calcDist(hand[8],hand[5]) - scale * 0.025
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Start
                pointRM = tk.Tk()
                pointRM.attributes('-topmost',True)
                pointRM.overrideredirect(1)
                pointRM.eval('tk::PlaceWindow . center')
                pointCanv = tk.Canvas(pointRM,width=256,height=256)
                pointCanv.pack()
                setStatus("Pointing")
                gN = 2
            if calcDist(hand[4],hand[5]) < scale * 0.1 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Start
                oldCords[0][0] = handAvg[0][0]
                oldCords[0][1] = handAvg[0][1]
                setStatus("Grabbing")
                gN = 3  
        if gN==1:
            if calcDist(hand[4],hand[8]) < scale * 0.05 and calcDist(hand[12],hand[0]) > scale * 0.2 and calcDist(hand[16],hand[0]) > scale * 0.2:
                #Pinch Loop
                if handAvg[8][0] - oldCords[8][0] > scale * 0.1:
                    keyboard.press_and_release("shift+right")
                    gN = 0
                if handAvg[8][0] - oldCords[8][0] < scale * -0.1:
                    keyboard.press_and_release("shift+left")
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] > scale * 0.1:
                    keyboard.press_and_release("shift+down")
                    gN = 0
                if handAvg[8][1] - oldCords[8][1] < scale * -0.1:
                    keyboard.press_and_release("shift+up")
                    gN = 0
            else:
                setStatus("No Gesture Detected - Browser")
                #Pinch Release
                gN = 0
        if gN==2:
            temp = calcDist(hand[8],hand[5])
            if temp > calcDist(hand[12],hand[9]) and temp > calcDist(hand[16],hand[13]) and temp > calcDist(hand[20],hand[17]):
                #Point Loop
                pointCanv.delete('all')
                if hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='yellow')
                else:
                    pointCanv.create_polygon([0,4,0,252,124,128],fill='white')
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='yellow')
                else:
                    pointCanv.create_polygon([4,0,252,0,128,124],fill='white')
                if hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='yellow')
                else:
                    pointCanv.create_polygon([256,4,256,252,132,128],fill='white')
                if hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='yellow')
                else:
                    pointCanv.create_polygon([4,256,252,256,128,132],fill='white')
                pointCanv.create_text(128, 32, text="Media",font=('Helvetica','15','bold'))
                pointCanv.create_text(208, 128, text="Mouse",font=('Helvetica','15','bold'))
                pointCanv.create_text(128, 208, text=confSoft.get(),font=('Helvetica','15','bold'))
                pointCanv.create_text(32, 128, text="Vivaldi",font=('Helvetica','15','bold'))
                pointCanv.pack()
            else:
                #Point Release
                if hand[8][1] < hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Up Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 1
                    setStatus("Confirmation - media")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to media",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                elif hand[8][0] > hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Right Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 2
                    setStatus("Confirmation - mouse")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to mouse",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                elif hand[8][1] > hand[5][1] and abs(hand[8][0] - hand[5][0]) < abs(hand[8][1] - hand[5][1]):
                    #Bottom Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 3
                    setStatus("Confirmation - " + confSoft.get())
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to "+confSoft.get(),font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                elif hand[8][0] < hand[5][0] and abs(hand[8][0] - hand[5][0]) > abs(hand[8][1] - hand[5][1]):
                    #Left Button Selected
                    pointRM.destroy()
                    gestMode = 0
                    pointSelect = 4
                    setStatus("Confirmation - Browser")
                    pointRM = tk.Tk()
                    pointRM.attributes('-topmost',True)
                    pointRM.overrideredirect(1)
                    pointCanv = tk.Canvas(pointRM,width=512,height=64)
                    pointCanv.create_text(256, 32, text="Are you sure you want to switch modes to Browser",font=('Helvetica','15','bold'))
                    pointCanv.pack()
                    pointRM.eval('tk::PlaceWindow . center')
                    prevGestMode = 1
                else:
                    setStatus("No Gesture Detected - Browser")
                gN = 0
        if gN==3:
            gn = 0
            if calcDist(hand[4],hand[6]) < scale * 0.2 and calcDist(hand[8],hand[1]) < scale * 0.1 and calcDist(hand[12],hand[0]) < scale * 0.1 and calcDist(hand[0],hand[5]) > scale * 0.1:
                #Grab Loop
                if handAvg[0][0] - oldCords[0][0] > scale * 0.1:
                    keyboard.press_and_release("ctrl+windows+left")
                    gN = 0
                if handAvg[0][0] - oldCords[0][0] < scale * -0.1:
                    keyboard.press_and_release("ctrl+windows+right")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] > scale * 0.1:
                    keyboard.press_and_release("ctrl+windows+down")
                    gN = 0
                if handAvg[0][1] - oldCords[0][1] < scale * -0.1:
                    keyboard.press_and_release("ctrl+windows+up")
                    gN = 0
                t = 0
            else:
                gN = 0
                setStatus("No Gesture Detected - Browser")
    else:
        gestMode = 1
def handTrack():
    global success, image
    if not success:
      print("Ignoring empty camera frame.")
      # If loading a video, use 'break' instead of 'continue'.
      

    # Flip the image horizontally for a later selfie-view display, and convert
    # the BGR image to RGB.
    image = cv2.cvtColor(cv2.flip(image, 1), cv2.COLOR_BGR2RGB)
    # To improve performance, optionally mark the image as not writeable to
    # pass by reference.
    image.flags.writeable = False
    results = hands.process(image)

    # Draw the hand annotations on the image.
    image.flags.writeable = True
    if results.multi_hand_landmarks:
      for hand_landmarks in results.multi_hand_landmarks:
        mp_drawing.draw_landmarks(
            image, hand_landmarks, mp_hands.HAND_CONNECTIONS)
        t = 0
        while t < 21:
            x = hand_landmarks.landmark[t].x
            y = hand_landmarks.landmark[t].y
            handAvg[t][0] = (handAvg[t][0] + x) / 2
            handAvg[t][1] = (handAvg[t][1] + y) / 2
            t = t + 1
        return handAvg
      
with mp_hands.Hands(
    min_detection_confidence=0.5,
    min_tracking_confidence=0.5,
    max_num_hands=1) as hands:
  while cap.isOpened():
    success, image = cap.read()
    handThread = concurrent.futures.ThreadPoolExecutor().submit(handTrack)
    chart.update()
    if handThread.result():
        gestures(handThread.result())
        drawPoints(handThread.result())

cap.release()